<template>
  <v-navigation-drawer
    v-bind="$attrs"
    v-model="drawer"
  >
    <v-select
      class="mx-2 my-1"
      label="Select a Caravan"
      :items="caravans"
    />
    <v-list avatar="avatar">
      <v-list-item :to="{ name: 'formulary' }">
        <v-list-item-avatar>
          <v-icon>mdi-account-card-details</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Formulário</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'persons' }">
        <v-list-item-avatar>
          <v-icon>mdi-account</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Pessoas</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'cards' }">
        <v-list-item-avatar>
          <v-icon>mdi-qrcode</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Cartões</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'scanner' }">
        <v-list-item-avatar>
          <v-icon>mdi-scanner</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Scanner</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'stations' }">
        <v-list-item-avatar>
          <v-icon>mdi-nfc</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Leitores</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'caravans' }">
        <v-list-item-avatar>
          <v-icon>mdi-calendar</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Caravanas</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item :to="{ name: 'metrics' }">
        <v-list-item-avatar>
          <v-icon>mdi-chart-line</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Métricas</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-divider />
      <v-list-item :to="{ name: 'users' }">
        <v-list-item-avatar>
          <v-icon>mdi-at</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Usuários</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-divider />
      <v-list-item @click="logout">
        <v-list-item-avatar>
          <v-icon>mdi-logout</v-icon>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title>Sair</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </v-list>
  </v-navigation-drawer>
</template>

<script lang="ts">
import Vue from 'vue'

import listCaravansQuery from '@/gql/CaravanList.gql'
import { mapGetters } from 'vuex'

export default Vue.extend({
  name: 'Drawer',
  props: {
    value: {
      type: Boolean,
      required: true
    }
  },
  computed: {
    ...mapGetters({ authToken: 'auth/token' }),
    drawer: {
      get (): boolean {
        return this.value
      },
      set (v: boolean) {
        this.$emit('input', v)
      }
    }
  },
  apollo: {
    caravans: {
      query: listCaravansQuery
    }
  },
  methods: {
    async logout () {
      await this.$store.dispatch('auth/logout')
      this.$router.go(0)
    }
  }
})
</script>
